
(define-macro (test expr . rest)
  (let-optionals rest ((expect #t)
                       (cmp? (if (null? rest)
                               '(lambda (a b) a)
                               'equal?))
                       (name expr)
                       (group #f))
    `(register-test ',group
                    ',name
                    (lambda () ,expr)
                    (lambda () ,expect)
                    ,cmp?)))

(define-macro (test-group group-name . rest)
  `(begin
     ,@(map
         (lambda (test)
           (let-optionals (cddr test) ((expect #t)
                                       (cmp? (if (null? rest)
                                               '(lambda (a b) a)
                                               'equal?))
                                       (name (cadr test)))
           `  (test ,(cadr test) ,expect ,cmp? ,name ,group-name)))
         rest)))
